=== modified file 'lisp/progmodes/sql.el'
--- old/lisp/progmodes/sql.el	2010-01-13 08:35:10 +0000
+++ new/lisp/progmodes/sql.el	2010-04-16 03:07:36 +0000
@@ -1576,9 +1880,10 @@
 "then" "to" "transaction" "truncate" "type" "uncommitted" "union"
 "unique" "unlock" "update" "use" "using" "values" "when" "where"
 "with" "write" "xor"
-))
+)
 
-	(mysql-types (sql-keywords-re
+     ;; MySQL Data Types
+     (sql-font-lock-keywords-builder 'font-lock-type-face nil
 "bigint" "binary" "bit" "blob" "bool" "boolean" "char" "curve" "date"
 "datetime" "dec" "decimal" "double" "enum" "fixed" "float" "geometry"
 "geometrycollection" "int" "integer" "line" "linearring" "linestring"
@@ -1590,16 +1895,12 @@
 "zerofill"
 )))
 
-    `((,mysql-funcs    . font-lock-builtin-face)
-      (,mysql-keywords . font-lock-keyword-face)
-      (,mysql-types    . font-lock-type-face)))
-
   "MySQL SQL keywords used by font-lock.
 
 This variable is used by `sql-mode' and `sql-interactive-mode'.  The
 regular expressions are created during compilation by calling the
 function `regexp-opt'.  Therefore, take a look at the source before
-you define your own sql-mode-mysql-font-lock-keywords.")
+you define your own `sql-mode-mysql-font-lock-keywords'.")
 
 (defvar sql-mode-sqlite-font-lock-keywords nil
   "SQLite SQL keywords used by font-lock.
@@ -1607,7 +1908,7 @@
 This variable is used by `sql-mode' and `sql-interactive-mode'.  The
 regular expressions are created during compilation by calling the
 function `regexp-opt'.  Therefore, take a look at the source before
-you define your own sql-mode-sqlite-font-lock-keywords.")
+you define your own `sql-mode-sqlite-font-lock-keywords'.")
 
 (defvar sql-mode-db2-font-lock-keywords nil
   "DB2 SQL keywords used by font-lock.
@@ -1615,58 +1916,141 @@
 This variable is used by `sql-mode' and `sql-interactive-mode'.  The
 regular expressions are created during compilation by calling the
 function `regexp-opt'.  Therefore, take a look at the source before
-you define your own sql-mode-db2-font-lock-keywords.")
+you define your own `sql-mode-db2-font-lock-keywords'.")
 
 (defvar sql-mode-font-lock-keywords nil
   "SQL keywords used by font-lock.
 
 Setting this variable directly no longer has any affect.  Use
 `sql-product' and `sql-add-product-keywords' to control the
-highlighting rules in sql-mode.")
+highlighting rules in `sql-mode'.")
 
 
 
 ;;; SQL Product support functions
 
-(defun sql-product-feature (feature &optional product)
-  "Lookup `feature' needed to support the current SQL product.
-
-See \[sql-product-alist] for a list of products and supported features."
-  (plist-get
-   (cdr (assoc (or product sql-product)
-	       sql-product-alist))
-   feature))
+(defun sql-add-product (product display &rest plist)
+  "Add support for a database product in `sql-mode'.
+
+Add PRODUCT to `sql-product-alist' which enables `sql-mode' to
+properly support syntax highlighting and interactive interaction.
+DISPLAY is the name of the SQL product that will appear in the
+menu bar and in messages.  PLIST initializes the product
+configuration."
+
+  ;; Don't do anything if the product is already supported
+  (if (assoc product sql-product-alist)
+      (message "Product `%s' is already defined" product)
+
+    ;; Add product to the alist
+    (add-to-list 'sql-product-alist `((,product :display ,display . ,plist)))
+    ;; Add a menu item to the SQL->Product menu
+    (easy-menu-add-item sql-mode-menu '("Product")
+			;; Each product is represented by a radio
+			;; button with it's display name.
+			`[,display
+			  (lambda () (interactive) (sql-set-product ',product))
+			 :style radio
+			 :selected (eq sql-product ',product)]
+			;; Maintain the product list in
+			;; (case-insensitive) alphabetic order of the
+			;; display names.  Loop thru each keymap item
+			;; looking for an item whose display name is
+			;; after this product's name.
+			(let ((next-item)
+			      (down-display (downcase display)))
+			  (map-keymap (lambda (k b)
+					(when (and (not next-item)
+						   (string-lessp down-display
+								 (downcase (cadr b))))
+					  (setq next-item k)))
+				      (easy-menu-get-map sql-mode-menu '("Product")))
+			  next-item))
+    product))
+
+(defun sql-del-product (product)
+  "Remove support for PRODUCT in `sql-mode'."
+
+  ;; Remove the menu item based on the display name
+  (easy-menu-remove-item sql-mode-menu '("Product") (sql-get-product-feature product :display))
+  ;; Remove the product alist item
+  (setq sql-product-alist (assq-delete-all product sql-product-alist))
+  nil)
+
+(defun sql-set-product-feature (product feature newvalue)
+  "Set FEATURE of database PRODUCT to NEWVALUE.
+
+The PRODUCT must be a symbol which identifies the database
+product.  The product must have already exist on the product
+list.  See `sql-add-product' to add new products.  The FEATURE
+argument must be a plist keyword accepted by
+`sql-product-alist'."
+
+  (let ((p (assoc product sql-product-alist)))
+    (if p
+	(setcdr p (plist-put (cdr p) feature newvalue))
+      (message "`%s' is not a known product; use `sql-add-product' to add it first." product))))
+
+(defun sql-get-product-feature (product feature &optional fallback)
+  "Lookup FEATURE associated with a SQL PRODUCT.
+
+If the FEATURE is nil for PRODUCT, and FALLBACK is specified,
+then the FEATURE associated with the FALLBACK product is
+returned.
+
+See `sql-product-alist' for a list of products and supported features."
+  (let (v)
+    ;; Lookup feature for product
+    (setq v (plist-get
+	     (cdr (assoc product sql-product-alist))
+	     feature))
+
+    ;; If no value and fallback, lookup feature for fallback
+    (if (and (not v)
+	     fallback
+	     (not (eq product fallback)))
+	(setq v (plist-get
+		 (cdr (assoc fallback sql-product-alist))
+		 feature)))
+
+    ;; Return the value
+    v))
 
 (defun sql-product-font-lock (keywords-only imenu)
-  "Sets `font-lock-defaults' and `font-lock-keywords' based on
-the product-specific keywords and syntax-alists defined in
-`sql-product-alist'."
+  "Configures font-lock and imenu with product-specific settings.
+
+The KEYWORDS-ONLY flag is passed to font-lock to specify whether
+only keywords should be hilighted and syntactic hilighting
+skipped.  The IMENU flag indicates whether `imenu-mode' should
+also be configured."
+
   (let
       ;; Get the product-specific syntax-alist.
       ((syntax-alist
 	(append
-	 (sql-product-feature :syntax-alist)
+	 (sql-get-product-feature sql-product :syntax-alist)
 	 '((?_ . "w") (?. . "w")))))
 
     ;; Get the product-specific keywords.
     (setq sql-mode-font-lock-keywords
 	  (append
 	   (unless (eq sql-product 'ansi)
-	     (eval (sql-product-feature :font-lock)))
+	     (symbol-value (sql-get-product-feature sql-product :font-lock)))
 	   ;; Always highlight ANSI keywords
-	   (eval (sql-product-feature :font-lock 'ansi))
+	   (symbol-value (sql-get-product-feature 'ansi :font-lock))
 	   ;; Fontify object names in CREATE, DROP and ALTER DDL
 	   ;; statements
 	   (list sql-mode-font-lock-object-name)))
 
     ;; Setup font-lock.  Force re-parsing of `font-lock-defaults'.
-    (set (make-local-variable 'font-lock-set-defaults) nil)
+    (kill-local-variable 'font-lock-set-defaults)
     (setq font-lock-defaults (list 'sql-mode-font-lock-keywords
 				   keywords-only t syntax-alist))
 
     ;; Force font lock to reinitialize if it is already on
     ;; Otherwise, we can wait until it can be started.
     (when (and (fboundp 'font-lock-mode)
+	       (boundp 'font-lock-mode)
 	       font-lock-mode)
       (font-lock-mode-internal nil)
       (font-lock-mode-internal t))
@@ -1683,7 +2067,7 @@
 
     ;; Setup imenu; it needs the same syntax-alist.
     (when imenu
-	(setq imenu-syntax-alist syntax-alist))))
+      (setq imenu-syntax-alist syntax-alist))))
 
 ;;;###autoload
 (defun sql-add-product-keywords (product keywords &optional append)
@@ -1705,7 +2089,7 @@
 adds a fontification pattern to fontify identifiers ending in
 `_t' as data types."
 
-  (let ((font-lock (sql-product-feature :font-lock product))
+  (let ((font-lock (sql-get-product-feature product :font-lock))
 	old)
     (setq old (eval font-lock))
     (set font-lock
@@ -1727,7 +2111,8 @@
     (sql-product-font-lock nil t)
 
     ;; Set the mode name to include the product.
-    (setq mode-name (concat "SQL[" (prin1-to-string sql-product) "]"))))
+    (setq mode-name (concat "SQL[" (or (sql-get-product-feature sql-product :display)
+				       (prin1-to-string sql-product)) "]"))))
 
 (defun sql-set-product (product)
   "Set `sql-product' to product and enable appropriate
@@ -1788,6 +2173,30 @@
     (newline))
   (indent-according-to-mode))
 
+(defun sql-help-list-products (indent freep)
+  "Generate listing of products available for use under SQLi.
+
+List products with :free-softare attribute set to FREEP.  Indent
+each line with INDENT."
+
+  (let (sqli-func doc)
+    (setq doc "")
+    (dolist (p sql-product-alist)
+      (setq sqli-func (intern (concat "sql-" (symbol-name (car p)))))
+
+      (if (and (fboundp sqli-func)
+	       (eq (sql-get-product-feature (car p) :free-software) freep))
+	(setq doc
+	      (concat doc
+		      indent
+		      (or (sql-get-product-feature (car p) :display)
+			  (symbol-name (car p)))
+		      ":\t"
+		      "\\["
+		      (symbol-name sqli-func)
+		      "]\n"))))
+    doc))
+
 ;;;###autoload
 (defun sql-help ()
   "Show short help for the SQL modes.
@@ -1797,24 +2206,17 @@
 
 Use the following commands to start a specific SQL interpreter:
 
-    PostGres: \\[sql-postgres]
-    MySQL: \\[sql-mysql]
-    SQLite: \\[sql-sqlite]
+    \\\\FREE
 
 Other non-free SQL implementations are also supported:
 
-    Solid: \\[sql-solid]
-    Oracle: \\[sql-oracle]
-    Informix: \\[sql-informix]
-    Sybase: \\[sql-sybase]
-    Ingres: \\[sql-ingres]
-    Microsoft: \\[sql-ms]
-    DB2: \\[sql-db2]
-    Interbase: \\[sql-interbase]
-    Linter: \\[sql-linter]
+    \\\\NONFREE
 
 But we urge you to choose a free implementation instead of these.
 
+You can also use \\[sql-product-interactive] to invoke the
+interpreter for the current `sql-product'.
+
 Once you have the SQLi buffer, you can enter SQL statements in the
 buffer.  The output generated is appended to the buffer and a new prompt
 is generated.  See the In/Out menu in the SQLi buffer for some functions
@@ -1829,6 +2231,30 @@
 buffer to the interactive SQL buffer (SQLi mode).  The results are
 appended to the SQLi buffer without disturbing your SQL buffer."
   (interactive)
+
+  ;; Insert references to loaded products into the help buffer string
+  (let ((doc (documentation 'sql-help t))
+	changedp)
+    (setq changedp nil)
+
+    ;; Insert FREE software list
+    (when (string-match "^\\(\\s-*\\)[\\\\][\\\\]FREE\\s-*\n" doc 0)
+      (setq doc (replace-match (sql-help-list-products (match-string 1 doc) t)
+			       t t doc 0)
+	    changedp t))
+
+    ;; Insert non-FREE software list
+    (when (string-match "^\\(\\s-*\\)[\\\\][\\\\]NONFREE\\s-*\n" doc 0)
+      (setq doc (replace-match (sql-help-list-products (match-string 1 doc) nil)
+			       t t doc 0)
+	    changedp t))
+
+    ;; If we changed the help text, save the change so that the help
+    ;; sub-system will see it
+    (when changedp
+      (put 'sql-help 'function-documentation doc)))
+
+  ;; Call help on this function
   (describe-function 'sql-help))
 
 (defun sql-read-passwd (prompt &optional default)
@@ -1844,12 +2270,13 @@
 `sql-server-history' and `database-history'.  Passwords are not stored
 in a history.
 
-Parameter WHAT is a list of the arguments passed to this function.
-The function asks for the username if WHAT contains symbol `user', for
-the password if it contains symbol `password', for the server if it
-contains symbol `server', and for the database if it contains symbol
-`database'.  The members of WHAT are processed in the order in which
-they are provided.
+Parameter WHAT is a list of tokens passed as arguments in the
+function call.  The function asks for the username if WHAT
+contains the symbol `user', for the password if it contains the
+symbol `password', for the server if it contains the symbol
+`server', and for the database if it contains the symbol
+`database'.  The members of WHAT are processed in the order in
+which they are provided.
 
 In order to ask the user for username, password and database, call the
 function like this: (sql-get-login 'user 'password 'database)."
@@ -1859,25 +2286,30 @@
      ((eq (car what) 'user)		; user
       (setq sql-user
 	    (read-from-minibuffer "User: " sql-user nil nil
-				  sql-user-history)))
+				  'sql-user-history)))
      ((eq (car what) 'password)		; password
       (setq sql-password
 	    (sql-read-passwd "Password: " sql-password)))
+
      ((eq (car what) 'server)		; server
       (setq sql-server
 	    (read-from-minibuffer "Server: " sql-server nil nil
-				  sql-server-history)))
+				  'sql-server-history)))
+     ((eq (car what) 'port)		; port
+      (setq sql-port
+	    (read-from-minibuffer "Port: " sql-port nil nil
+				  'sql-port-history)))
      ((eq (car what) 'database)		; database
       (setq sql-database
 	    (read-from-minibuffer "Database: " sql-database nil nil
-				  sql-database-history))))
+				  'sql-database-history))))
     (setq what (cdr what))))
 
 (defun sql-find-sqli-buffer ()
   "Return the current default SQLi buffer or nil.
 In order to qualify, the SQLi buffer must be alive,
 be in `sql-interactive-mode' and have a process."
-  (let ((default-buffer (default-value 'sql-buffer)))
+  (let ((default-buffer (default-value 'sqli-buffer)))
     (if (and (buffer-live-p default-buffer)
 	     (get-buffer-process default-buffer))
 	default-buffer
@@ -1899,20 +2331,20 @@
 This function checks all SQL buffers for their SQLi buffer.  If their
 SQLi buffer is nonexistent or has no process, it is set to the current
 default SQLi buffer.  The current default SQLi buffer is determined
-using `sql-find-sqli-buffer'.  If `sql-buffer' is set,
+using `sql-find-sqli-buffer'.  If `sqli-buffer' is set,
 `sql-set-sqli-hook' is run."
   (interactive)
   (save-excursion
     (let ((buflist (buffer-list))
 	  (default-sqli-buffer (sql-find-sqli-buffer)))
-      (setq-default sql-buffer default-sqli-buffer)
+      (setq-default sqli-buffer default-sqli-buffer)
       (while (not (null buflist))
 	(let ((candidate (car buflist)))
 	  (set-buffer candidate)
 	  (if (and (derived-mode-p 'sql-mode)
-		   (not (buffer-live-p sql-buffer)))
+		   (not (buffer-live-p sqli-buffer)))
 	      (progn
-		(setq sql-buffer default-sqli-buffer)
+		(setq sqli-buffer default-sqli-buffer)
 		(run-hooks 'sql-set-sqli-hook))))
 	(setq buflist (cdr buflist))))))
 
@@ -1920,14 +2352,14 @@
   "Set the SQLi buffer SQL strings are sent to.
 
 Call this function in a SQL buffer in order to set the SQLi buffer SQL
-strings are sent to.  Calling this function sets `sql-buffer' and runs
+strings are sent to.  Calling this function sets `sqli-buffer' and runs
 `sql-set-sqli-hook'.
 
 If you call it from a SQL buffer, this sets the local copy of
-`sql-buffer'.
+`sqli-buffer'.
 
 If you call it from anywhere else, it sets the global copy of
-`sql-buffer'."
+`sqli-buffer'."
   (interactive)
   (let ((default-buffer (sql-find-sqli-buffer)))
     (if (null default-buffer)
@@ -1942,20 +2374,20 @@
 	  (error "Buffer %s is no SQLi buffer" (buffer-name new-buffer)))
       (if new-buffer
 	  (progn
-	    (setq sql-buffer new-buffer)
+	    (setq sqli-buffer new-buffer)
 	    (run-hooks 'sql-set-sqli-hook))))))
 
 (defun sql-show-sqli-buffer ()
   "Show the name of current SQLi buffer.
 
 This is the buffer SQL strings are sent to.  It is stored in the
-variable `sql-buffer'.  See `sql-help' on how to create such a buffer."
+variable `sqli-buffer'.  See `sql-help' on how to create such a buffer."
   (interactive)
-  (if (null (buffer-live-p sql-buffer))
+  (if (null (buffer-live-p sqli-buffer))
       (message "%s has no SQLi buffer set." (buffer-name (current-buffer)))
-    (if (null (get-buffer-process sql-buffer))
-	(message "Buffer %s has no process." (buffer-name sql-buffer))
-      (message "Current SQLi buffer is %s." (buffer-name sql-buffer)))))
+    (if (null (get-buffer-process sqli-buffer))
+	(message "Buffer %s has no process." (buffer-name sqli-buffer))
+      (message "Current SQLi buffer is %s." (buffer-name sqli-buffer)))))
 
 (defun sql-make-alternate-buffer-name ()
   "Return a string that can be used to rename a SQLi buffer.
@@ -1984,7 +2416,7 @@
   (interactive)
   (let ((column))
     (save-excursion
-      (setq column (buffer-substring
+      (setq column (buffer-substring-no-properties
 		  (progn (forward-char 1) (backward-sexp 1) (point))
 		  (progn (forward-sexp 1) (point))))
       (goto-char (point-max))
@@ -2015,61 +2447,90 @@
 (defvar sql-placeholder-history nil
   "History of placeholder values used.")
 
-(defun sql-query-placeholders-and-send (proc string)
-  "Send to PROC input STRING, maybe replacing placeholders.
-Placeholders are words starting with and ampersand like &this.
-This function is used for `comint-input-sender' if using `sql-oracle' on NT."
-  (while (string-match "&\\(\\sw+\\)" string)
-    (setq string (replace-match
-		  (read-from-minibuffer
-		   (format "Enter value for %s: " (match-string 1 string))
-		   nil nil nil sql-placeholder-history)
-		  t t string)))
-  (comint-send-string proc string)
-  (if comint-input-sender-no-newline
-      (if (not (string-equal string ""))
-	  (process-send-eof))
-    (comint-send-string proc "\n")))
+(defun sql-placeholders-filter (string)
+  "Replace placeholders in STRING.
+Placeholders are words starting with and ampersand like &this."
+
+  (when sql-oracle-scan-on
+    (while (string-match "&\\(\\sw+\\)" string)
+      (setq string (replace-match
+		    (read-from-minibuffer
+		     (format "Enter value for %s: " (match-string 1 string))
+		     nil nil nil 'sql-placeholder-history)
+		    t t string))))
+    string)
 
 ;; Using DB2 interactively, newlines must be escaped with " \".
 ;; The space before the backslash is relevant.
-(defun sql-escape-newlines-and-send (proc string)
-  "Send to PROC input STRING, escaping newlines if necessary.
+(defun sql-escape-newlines-filter (string)
+  "Escapes newlines in STRING.
 Every newline in STRING will be preceded with a space and a backslash."
   (let ((result "") (start 0) mb me)
     (while (string-match "\n" string start)
       (setq mb (match-beginning 0)
-	    me (match-end 0))
-      (if (and (> mb 1)
-	       (string-equal " \\" (substring string (- mb 2) mb)))
-	  (setq result (concat result (substring string start me)))
-	(setq result (concat result (substring string start mb) " \\\n")))
-      (setq start me))
-    (setq result (concat result (substring string start)))
-    (comint-send-string proc result)
-    (if comint-input-sender-no-newline
-	(if (not (string-equal string ""))
-	    (process-send-eof))
-      (comint-send-string proc "\n"))))
+	    me (match-end 0)
+	    result (concat result
+			   (substring string start mb)
+			   (if (and (> mb 1)
+				    (string-equal " \\" (substring string (- mb 2) mb)))
+			       "" " \\\n"))
+	    start me))
+    (concat result (substring string start))))
 
 
 
+;;; Input sender for SQLi buffers
+
+(defun sqli-input-sender (proc string)
+  "Sends STRING to PROC after applying filters."
+
+  (let* ((product (with-current-buffer (process-buffer proc) sql-product))
+	 (filter  (sql-get-product-feature product :sqli-input-filter)))
+
+    ;; Send the string
+    (comint-simple-send proc (funcall (or filter 'identity) string))))
+
 ;;; Sending the region to the SQLi buffer.
 
+(defun sql-send-string (str)
+  "Send the string STR to the SQL process."
+  (interactive "sSQL Text: ")
+
+  (let (comint-input-sender-no-newline proc)
+    (if (buffer-live-p sqli-buffer)
+	(progn
+	  ;; Ignore the hoping around...
+	  (save-excursion
+	    ;; Get the process
+	    (setq proc (get-buffer-process sqli-buffer))
+
+	    ;; Set product context
+	    (with-current-buffer sqli-buffer
+	      ;; Send the string
+	      (sqli-input-sender proc str)
+
+	      ;; Send a newline if there wasn't one on the end of the string
+	      (unless (string-equal "\n" (substring str (1- (length str))))
+		(comint-send-string proc "\n"))
+
+	      ;; Send a command terminator if we must
+	      (if sql-send-terminator
+		  (sql-send-magic-terminator sqli-buffer str sql-send-terminator))
+
+	      (message "Sent string to buffer %s." (buffer-name sqli-buffer))))
+
+	  ;; Display the sql buffer
+	  (if sql-pop-to-buffer-after-send-region
+	      (pop-to-buffer sqli-buffer)
+	    (display-buffer sqli-buffer)))
+
+    ;; We don't have no stinkin' sql
+    (message "No SQL process started."))))
+
 (defun sql-send-region (start end)
   "Send a region to the SQL process."
   (interactive "r")
-  (if (buffer-live-p sql-buffer)
-      (save-excursion
-	(comint-send-region sql-buffer start end)
-	(if (string-match "\n$" (buffer-substring start end))
-	    ()
-	  (comint-send-string sql-buffer "\n"))
-	(message "Sent string to buffer %s." (buffer-name sql-buffer))
-	(if sql-pop-to-buffer-after-send-region
-	    (pop-to-buffer sql-buffer)
-	  (display-buffer sql-buffer)))
-    (message "No SQL process started.")))
+  (sql-send-string (buffer-substring-no-properties start end)))
 
 (defun sql-send-paragraph ()
   "Send the current paragraph to the SQL process."
@@ -2087,29 +2548,46 @@
   (interactive)
   (sql-send-region (point-min) (point-max)))
 
-(defun sql-send-string (str)
-  "Send a string to the SQL process."
-  (interactive "sSQL Text: ")
-  (if (buffer-live-p sql-buffer)
-      (save-excursion
-        (comint-send-string sql-buffer str)
-        (comint-send-string sql-buffer "\n")
-        (message "Sent string to buffer %s." (buffer-name sql-buffer))
-        (if sql-pop-to-buffer-after-send-region
-            (pop-to-buffer sql-buffer)
-          (display-buffer sql-buffer)))
-    (message "No SQL process started.")))
+(defun sql-send-magic-terminator (buf str terminator)
+  "Sends TERMINATOR to buffer BUF if its not present in STR."
+  (let (pat term)
+    ;; If flag is merely on(t), get product-specific terminator
+    (if (eq terminator t)
+	(setq terminator (sql-get-product-feature sql-product :sql-send-terminator)))
+
+    ;; If there is no terminator specified, use default ";"
+    (unless terminator
+      (setq terminator ";"))
+
+    ;; Parse the setting into the pattern and the terminator string
+    (cond ((stringp terminator)
+	   (setq pat (regexp-quote terminator)
+		 term terminator))
+	  ((consp terminator)
+	   (setq pat (car terminator)
+		 term (cdr terminator)))
+	  (t
+	   nil))
+
+    ;; Check to see if the pattern is present in the str already sent
+    (unless (and pat term
+		 (string-match (concat pat "\n?\\'") str))
+      (comint-send-string buf (concat term "\n")))))
+
+(defun sql-remove-tabs-filter (str)
+  "Replace tab characters with spaces."
+  (replace-regexp-in-string "\t" " " str nil t))
 
 (defun sql-toggle-pop-to-buffer-after-send-region (&optional value)
   "Toggle `sql-pop-to-buffer-after-send-region'.
 
 If given the optional parameter VALUE, sets
-sql-toggle-pop-to-buffer-after-send-region to VALUE."
+`sql-toggle-pop-to-buffer-after-send-region' to VALUE."
   (interactive "P")
   (if value
       (setq sql-pop-to-buffer-after-send-region value)
     (setq sql-pop-to-buffer-after-send-region
-	  (null sql-pop-to-buffer-after-send-region ))))
+	  (null sql-pop-to-buffer-after-send-region))))
 
 
 
@@ -2127,11 +2605,11 @@
 Customization: Entry to this mode runs the `sql-mode-hook'.
 
 When you put a buffer in SQL mode, the buffer stores the last SQLi
-buffer created as its destination in the variable `sql-buffer'.  This
+buffer created as its destination in the variable `sqli-buffer'.  This
 will be the buffer \\[sql-send-region] sends the region to.  If this
 SQLi buffer is killed, \\[sql-send-region] is no longer able to
 determine where the strings should be sent to.  You can set the
-value of `sql-buffer' using \\[sql-set-sqli-buffer].
+value of `sqli-buffer' using \\[sql-set-sqli-buffer].
 
 For information on how to create multiple SQLi buffers, see
 `sql-interactive-mode'.
@@ -2156,7 +2634,7 @@
   (make-local-variable 'comment-start)
   (setq comment-start "--")
   ;; Make each buffer in sql-mode remember the "current" SQLi buffer.
-  (make-local-variable 'sql-buffer)
+  (make-local-variable 'sqli-buffer)
   ;; Add imenu support for sql-mode.  Note that imenu-generic-expression
   ;; is buffer-local, so we don't need a local-variable for it.  SQL is
   ;; case-insensitive, that's why we have to set imenu-case-fold-search.
@@ -2252,24 +2730,29 @@
 \(setq comint-output-filter-functions
        \(function (lambda (STR) (comint-show-output))))"
   (delay-mode-hooks (comint-mode))
+
   ;; Get the `sql-product' for this interactive session.
   (set (make-local-variable 'sql-product)
        (or sql-interactive-product
 	   sql-product))
+
   ;; Setup the mode.
   (setq major-mode 'sql-interactive-mode)
-  (setq mode-name (concat "SQLi[" (prin1-to-string sql-product) "]"))
+  (setq mode-name (concat "SQLi[" (or (sql-get-product-feature sql-product :display)
+				      (prin1-to-string sql-product)) "]"))
   (use-local-map sql-interactive-mode-map)
   (if sql-interactive-mode-menu
       (easy-menu-add sql-interactive-mode-menu)) ; XEmacs
   (set-syntax-table sql-mode-syntax-table)
   (make-local-variable 'sql-mode-font-lock-keywords)
   (make-local-variable 'font-lock-defaults)
+
   ;; Note that making KEYWORDS-ONLY nil will cause havoc if you try
   ;; SELECT 'x' FROM DUAL with SQL*Plus, because the title of the column
   ;; will have just one quote.  Therefore syntactic hilighting is
   ;; disabled for interactive buffers.  No imenu support.
   (sql-product-font-lock t nil)
+
   ;; Enable commenting and uncommenting of the region.
   (make-local-variable 'comment-start)
   (setq comment-start "--")
@@ -2278,22 +2761,25 @@
   (setq local-abbrev-table sql-mode-abbrev-table)
   (setq abbrev-all-caps 1)
   ;; Exiting the process will call sql-stop.
-  (set-process-sentinel (get-buffer-process sql-buffer) 'sql-stop)
+  (set-process-sentinel (get-buffer-process sqli-buffer) 'sql-stop)
   ;; Create a usefull name for renaming this buffer later.
   (make-local-variable 'sql-alternate-buffer-name)
   (setq sql-alternate-buffer-name (sql-make-alternate-buffer-name))
   ;; User stuff.  Initialize before the hook.
   (set (make-local-variable 'sql-prompt-regexp)
-       (sql-product-feature :sqli-prompt-regexp))
+       (sql-get-product-feature sql-product :sqli-prompt-regexp))
   (set (make-local-variable 'sql-prompt-length)
-       (sql-product-feature :sqli-prompt-length))
+       (sql-get-product-feature sql-product :sqli-prompt-length))
   (make-local-variable 'sql-input-ring-separator)
   (make-local-variable 'sql-input-ring-file-name)
-  ;; Run hook.
+  (setq comint-process-echoes t)
+  ;; Run the mode hook (along with comint's hooks).
   (run-mode-hooks 'sql-interactive-mode-hook)
   ;; Set comint based on user overrides.
   (setq comint-prompt-regexp sql-prompt-regexp)
   (setq left-margin sql-prompt-length)
+  ;; Install input sender
+  (set (make-local-variable 'comint-input-sender) 'sqli-input-sender)
   ;; People wanting a different history file for each
   ;; buffer/process/client/whatever can change separator and file-name
   ;; on the sql-interactive-mode-hook.
@@ -2312,7 +2798,7 @@
 This function is a sentinel watching the SQL interpreter process.
 Sentinels will always get the two parameters PROCESS and EVENT."
   (comint-write-input-ring)
-  (if (and (eq (current-buffer) sql-buffer)
+  (if (and (eq (current-buffer) sqli-buffer)
 	   (not buffer-read-only))
       (insert (format "\nProcess %s %s\n" process event))
     (message "Process %s %s" process event)))
@@ -2323,7 +2809,7 @@
 
 ;;;###autoload
 (defun sql-product-interactive (&optional product)
-  "Run product interpreter as an inferior process.
+  "Run PRODUCT interpreter as an inferior process.
 
 If buffer `*SQL*' exists but no process is running, make a new process.
 If buffer exists and a process is running, just switch to buffer `*SQL*'.
@@ -2331,21 +2817,60 @@
 \(Type \\[describe-mode] in the SQL buffer for a list of commands.)"
   (interactive)
   (setq product (or product sql-product))
-  (when (sql-product-feature :sqli-connect product)
-    (if (comint-check-proc "*SQL*")
-	(pop-to-buffer "*SQL*")
-      ;; Get credentials.
-      (apply 'sql-get-login (sql-product-feature :sqli-login product))
-      ;; Connect to database.
-      (message "Login...")
-      (funcall (sql-product-feature :sqli-connect product))
-      ;; Set SQLi mode.
-      (setq sql-interactive-product product)
-      (setq sql-buffer (current-buffer))
-      (sql-interactive-mode)
-      ;; All done.
-      (message "Login...done")
-      (pop-to-buffer sql-buffer))))
+  (when (sql-get-product-feature product :sqli-connect)
+    (if (and sqli-buffer
+	     (comint-check-proc sqli-buffer))
+	(pop-to-buffer sqli-buffer)
+
+      ;; Is the current buffer in sql-mode and
+      ;; there is a buffer local setting of sqli-buffer
+      (let* ((start-buffer
+	      (and (derived-mode-p 'sql-mode)
+		   (current-buffer)))
+	     (start-sqli-buffer
+	      (and start-buffer
+		   (let (found)
+		     (dolist (var (buffer-local-variables))
+		       (and (consp var)
+			    (eq (car var) 'sqli-buffer)
+			    (buffer-live-p (cdr var))
+			    (get-buffer-process (cdr var))
+			    (setq found (cdr var))))
+		     found)))
+	     new-sqli-buffer)
+
+	;; Get credentials.
+	(apply 'sql-get-login
+	       (symbol-value (sql-get-product-feature product :sqli-login)))
+
+	;; Connect to database.
+	(message "Login...")
+	(funcall (sql-get-product-feature product :sqli-connect))
+
+	;; Set SQLi mode.
+	(setq sql-interactive-product product
+	      new-sqli-buffer (current-buffer)
+	      sqli-buffer new-sqli-buffer)
+	(sql-interactive-mode)
+
+	;; Set `sqli-buffer' in the start buffer
+	(when (and start-buffer (not start-sqli-buffer))
+	  (with-current-buffer start-buffer
+	    (setq sqli-buffer new-sqli-buffer)))
+
+	;; All done.
+	(message "Login...done")
+	(pop-to-buffer sqli-buffer)))))
+
+(defun sql-connect (program args)
+  "Set up a comint buffer to connect to the SQL processor.
+
+PROGRAM is the SQL command interpreter program.  ARGS is a list
+of strings which are passed as command line arguments."
+  (set-buffer
+   (if args
+       (apply 'make-comint "SQL" program nil args)
+     (make-comint "SQL" program nil))))
 
 ;;;###autoload
 (defun sql-oracle ()
@@ -2360,7 +2885,7 @@
 defaults, if set.  Additional command line parameters can be stored in
 the list `sql-oracle-options'.
 
-The buffer is put in sql-interactive-mode, giving commands for sending
+The buffer is put in `sql-interactive-mode', giving commands for sending
 input.  See `sql-interactive-mode'.
 
 To specify a coding system for converting non-ASCII characters
